# To start this program type the following in linux console:
# python cubePath3x3_case08.py 
# or 
# time python cubePath3x3.py (with running time being displayed)

# This program computes all paths from a start vertex to 
# and end vertex in a 3x3 cube with 27 vertices
# (see: http://physicsforums.com/showthread.php?t=460112)

# The algorithm is recursive (heavily influenced by Haskell)
# It resembles a breadth first search



# v: vertex, whose neighbours are examined in the next step

# visited: A boolean array that tells if a vertex i has been visited, e.g. visited[i]=True means i 
# has been visited

# lengthPath: This must be specified by the user in the function definition. If you want 
#             to have all vertices exactly once in your path, set lengthPath to 
#             the number of vertices of your graph. Here, it is set to 27 (total number 
#             of vertices).

# adjList: The graph written as an adjacency list

# path: saves the current path, e.g. [0,1] means the path consists of the vertices 0 and 1

# endVertex: this value must be specified by the user


def visitNeighbours(v,visited,lengthPath,adjList,path,endVertex,counter):
	if(lengthPath==27 and v==endVertex):
		counter[0] = counter[0]+1   # I only used a list here because I needed a global variable
		print path, counter[0]      # and lists are passed as "call by reference"
	else:
		for i in adjList[v]:
			if(visited[i]==False):
				visitedCopy = visited[:]   # [:] is the slicing operator for a copy 
				visitedCopy[i]=True
				pathCopy = path[:]
				pathCopy.append(i)
				visitNeighbours(i,visitedCopy,lengthPath+1,adjList,pathCopy,endVertex,counter)
				

def main():

	# define your graph
	adjList = [ 
	            [1,3,9],        [0,2,4,10],         [1,5,11], 
	            [0,4,6,12],     [1,3,5,7,13],       [2,4,8,14], 
	            [3,7,15],       [6,8,16],           [5,7,17],
	            [0,10,12,18],   [1,9,11,13,19],     [2,10,14,20],
	            [3,9,13,15,21], [4,10,12,14,16,22], [5,11,13,17,23],
	            [6,12,16,24],   [7,13,15,17,25],    [8,14,16,26],
	            [9,19,21],      [10,18,20,22],      [11,19,23],
	            [12,18,22,24],  [13,19,21,23,25],   [14,20,22,26],
	            [15,21,25],     [16,22,24,26],      [17,23,25]
	          ]
	
	
	visited = []
	for i in range(0,27):
		visited.append(False)
	
        # ----this part is for the user----	
	startVertex = 0
	endVertex = 8
	#----------------------------------
	
	path=[startVertex]
	visited[startVertex]=True
	counter = [0]
	lengthPath = 1
	
	
	visitNeighbours(startVertex,visited,lengthPath,adjList,path,endVertex,counter)
	
	
	

# execute main()
main()





'''
[0, 9, 18, 21, 24, 25, 26, 23, 22, 19, 20, 11, 14, 17, 16, 15, 12, 13, 10, 1, 2, 5, 4, 3, 6, 7, 8] 28431

real	6m43.729s
user	6m41.149s
sys	0m0.784s
'''


